/*
  v2.6
  Money Management Assistant
*/

#property copyright "Copyright Lee Bryant, Modify by AtApi(dumpinto@gmail.com)"
#property link      ""
#include <stdlib.mqh>


extern color   StopLossLineColor = Red;
extern color   entryLineColor = Blue;
extern color   TPLineColor = LimeGreen;
extern string  Risk_Notes="Risk as percentage";
extern double  risk=10.0;
extern bool    TradeManagment = TRUE;
extern int     FakeSL = 250;
extern int     FakeTP = 250;
extern string  Type_Notes="0=CFD/Other 1=Forex";
extern int     type=1;
extern bool Alert_With_Sound = TRUE;

color lastusedColor = Black;

string         stopLoss = "stopLoss",
               entry = "Entry Price",
               TP  ="Take Profit",
               positionType="",
               lastusedFont = "Arial",
               gs_164 = "";
               
double         datetimevar = 0.0,
               pipValue = 0.0,
               SLDbl=0.0,
               entryDbl=0.0,
               TPDbl=0.0,
               stopDistance=0.0,
               TPDistance=0.0,
               riskAmount=0.0,
               lotSize=0.0,
               pointMult=0.0,
               rrRatio=0.0,
               rrRatioClose=0.0,
               lotSizeClose=0.0,
               stopDistanceClose=0.0,
               stopDistancePoint=0.0,
               profitDistancePoint=0.0,
               swaplong=0.0,
               swapshort=0.0,
               spread2=0.0,
               seco=0.0,
               stopSpread=0.0,
               minu=0.0,
               entryvar,
               TPvar,
               SLvar,
               Poin,
               divider = 1,
               pointvalue = 1,
               lastusedFontSize = 9.0,
               values[3];
                  
int            n_digits = 0;
bool orderResult;               




int init() 
{
   info_init();
   
   ObjectDelete(stopLoss);
   ObjectDelete(TP);
   ObjectDelete(entry);

   if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;
   //Checking for unconvetional Point digits number
   if (Point == 0.00001) Poin = 0.0001; //5 digits
   else if (Point == 0.001) Poin = 0.01; //3 digits
   else Poin = Point; //Normal
   
   
   if (Poin > Point) 
   {
      divider = 10.0;
      n_digits = 1;
   }

   
   risk=risk/100;    // Convert input risk to percentage
   double oPrice,OP,TPr,SL;
   bool bexist,sexist,prof;
   
   
   returnparameters(oPrice,bexist,sexist,prof);
   getparameters(OP,TPr,SL);
   if (values[0] ==0) 
      {
         if (bexist == FALSE && prof == FALSE) {entryvar =Close[0]; TPvar = (entryvar + pointvalue*10);  SLvar =  (entryvar -pointvalue*10);}
         if (bexist == TRUE && prof == TRUE)   {entryvar =oPrice; TPvar = (Close[0] + pointvalue*10);  SLvar =  (entryvar -pointvalue*10);}
         if (bexist == TRUE && prof == FALSE)  {entryvar =oPrice; TPvar = (entryvar + pointvalue*10);  SLvar =  (Close[0]-pointvalue*10);}
         if (sexist == TRUE && prof == TRUE)   {entryvar =oPrice; TPvar = (Close[0] - pointvalue*10);  SLvar =  (entryvar +pointvalue*10);}
         if (sexist == TRUE && prof == FALSE)  {entryvar =oPrice; TPvar = (entryvar - pointvalue*10);  SLvar =  (Close[0]+pointvalue*10);}
      }
   if (values[0] !=0)  {entryvar =OP; TPvar = TPr;  SLvar = SL;}
   
      
   ObjectCreate(stopLoss, OBJ_HLINE, 0, datetimevar, SLvar);
   ObjectSet(stopLoss, OBJPROP_COLOR, StopLossLineColor);
   ObjectSet(stopLoss, OBJPROP_STYLE, STYLE_DASHDOTDOT);
   ObjectSet(stopLoss, OBJPROP_WIDTH, 1);
   
   ObjectCreate(entry, OBJ_HLINE, 0, datetimevar, entryvar);
   ObjectSet(entry, OBJPROP_COLOR, entryLineColor);
   ObjectSet(entry, OBJPROP_STYLE, STYLE_DASHDOTDOT);
   ObjectSet(entry, OBJPROP_WIDTH, 1);

   ObjectCreate(TP, OBJ_HLINE, 0, datetimevar, TPvar);
   ObjectSet(TP, OBJPROP_COLOR, TPLineColor);
   ObjectSet(TP, OBJPROP_STYLE, STYLE_DASHDOTDOT);
   ObjectSet(TP, OBJPROP_WIDTH, 1);
   start();
   return(0);
}

int deinit() 
{
   info_deinit();
   info_clear();
   
   ObjectDelete(stopLoss);
   ObjectDelete(TP);
   ObjectDelete(entry);
   return (0);
}

void start() 
{      
 
      RefreshRates();  
      checkforposition();
      if (TradeManagment) sendTS();
      entryDbl = MathRound(ObjectGet(entry, OBJPROP_PRICE1) / pointvalue) * pointvalue;
      TPDbl  = MathRound(ObjectGet(TP, OBJPROP_PRICE1) / pointvalue) * pointvalue;
      SLDbl = MathRound(ObjectGet(stopLoss, OBJPROP_PRICE1) / pointvalue) * pointvalue;
       writeparameters();
      swaplong=NormalizeDouble(MarketInfo(Symbol(),18),2);
      swapshort=NormalizeDouble(MarketInfo(Symbol(),19),2);
      spread2=(Ask-Bid);
      seco= (Time[4]-Time[5])-MathMod(CurTime(),Time[4]-Time[5]);
      minu=seco/60;
      RefreshRates(); 
      double Spread = (Ask - Bid) / Point;
      Spread=(NormalizeDouble(Spread / divider, 1));
   
      seco=(minu-MathFloor(minu))*60;
      minu=MathFloor(minu);  
      pipValue=MarketInfo(Symbol(),MODE_TICKVALUE);
      pointMult=(100/pointvalue);
  
      if(SLDbl>entryDbl) {positionType="Short";}
      if(SLDbl<entryDbl) {positionType="Long";}
      
      if(positionType=="Short")
      {
         stopDistanceClose=SLDbl-Close[0]+spread2;    // include spread in stop calculation
         stopDistance=SLDbl-entryDbl+spread2;         // include spread in stop calculation
         TPDistance=entryDbl-TPDbl;
         rrRatio=TPDistance/stopDistance;
         rrRatioClose=TPDistance/stopDistanceClose;
         stopSpread=SLDbl+spread2;
      }
      
      if(positionType=="Long")
      {
         stopDistanceClose=Close[0]-SLDbl+spread2;    // include spread in stop calculation
         stopDistance=entryDbl-SLDbl+spread2;         // include spread in stop calculation
         TPDistance=TPDbl-entryDbl;
         rrRatio=TPDistance/stopDistance; 
         rrRatioClose=TPDistance/stopDistanceClose;
         stopSpread=SLDbl-spread2;
      }
      
      if(type==0)
      {
         stopDistancePoint=(stopDistance*pointMult)*pipValue;
         profitDistancePoint=(TPDistance*pointMult)*pipValue;
      }
      if(type==1)
      {
         stopDistancePoint=stopDistance*pointMult;
         profitDistancePoint=TPDistance*pointMult;
      }
      
      riskAmount=AccountBalance()*risk;
      lotSize=NormalizeDouble((riskAmount/((stopDistance*pointMult)+Spread)/pipValue),3);
      lotSizeClose=NormalizeDouble((riskAmount/((stopDistanceClose*pointMult)+Spread)/pipValue),3);
      double projprof = profitDistancePoint * lotSize;
      if (TradeManagment) {checkforposition(); CloseOrders();}
      string l_dbl2str_0 = DoubleToStr(balanceDeviation(2), 2);
      string TM;
      if (TradeManagment) TM = "ON"; else TM = "OFF";
      
         info( 0, "MoneyManagement v2.6 Loaded Successfully ", Red, 9 );
         info( 1, "--------------------------------------", White, 9 );
         info( 2, "Account #" + AccountNumber() + " (" + AccountName() + "):", Black, 9 );
         info( 3, "Account Type: " + AccountServer(), Black, 9 );
         info( 4, "Server Time: " + TimeToStr(TimeCurrent(), TIME_SECONDS), Black, 9 );
         info( 5, "Leverage: 1:" + AccountLeverage(), Black, 9 );
         info( 6, "Spread: " + DoubleToStr(Spread,1) + " Pips", Black, 9 );
	      info( 7, "BuySwap: " + DoubleToStr(swaplong,2) + " SellSwap: " + DoubleToStr(swapshort,2) , Black, 9 );
         info( 8, "AccountEquity = " + DoubleToStr( AccountEquity(), 2 ) + " " +AccountCurrency(), Black );
         info( 9, "AccountBalance = " + DoubleToStr( AccountBalance(), 2 ) + " " +AccountCurrency(), Black );
         info( 10, "AccountFree Margin = " + DoubleToStr( AccountFreeMargin(), 2 ) + " " +AccountCurrency(), Black );
         if (AccountProfit() <= 0) info( 11, "AccountProfit = " + DoubleToStr( AccountProfit(), 2 ) + " " +AccountCurrency(), Red, 12 );
            else info( 11, "AccountProfit = " + DoubleToStr( AccountProfit(), 2 ) + " " +AccountCurrency(), Green, 12 );
      	info( 12, "Drawdown = " + l_dbl2str_0 + "%\n" , Red, 12 );
	      info( 13, "--------------------------------------", White, 9 );
	      if (TradeManagment) info( 14, "Trade Managment is " + TM, Green, 11 );  else info( 14, "Trade Managment is" + TM, Red, 11 );
	      info( 15, "Position Type: " + positionType, Magenta, 11 );
	      info( 16, "--------------------------------------", White, 9 );
	      info( 17, "Entry:  " + DoubleToStr(entryDbl,Digits) + "  SL:  " + DoubleToStr(SLDbl,Digits) + "  TP:  " + DoubleToStr(TPDbl,Digits), Blue, 9 );
         info( 18, "Time to next bar: " + DoubleToStr(minu,0) + " Min " + DoubleToStr(seco,0) + " Sec" , Black, 10 );
         info( 19, "Stop Distance: " + DoubleToStr(stopDistancePoint/100,1) + " Pips", Black, 10 );
	      info( 20, "Profit Distance: " + DoubleToStr(profitDistancePoint/100,1) + " Pips", Black, 10 );
	      if (projprof > 0) info( 21, "Projected Profit : " + DoubleToStr(projprof,2) + " " +AccountCurrency(), Green, 10 );
	         else info( 21, "Projected Profit : " + DoubleToStr(projprof,2) + " " +AccountCurrency(), Red, 10 );  
	      info( 22, "--------------------------------------", White, 9 );
	      info( 23, "Risk: " +DoubleToStr(risk*100,1) + "%",Red, 11 );
	      info( 24, "Risk Amount: " + DoubleToStr(riskAmount,2) + " " +AccountCurrency(), Yellow, 11 );
	      info( 25, "Lot Size: " + DoubleToStr(lotSize*10,2), Red, 11 );
	      info( 26, "R/R Ratio: " + DoubleToStr(rrRatio,3), Green, 11 );
	      info( 27, "--------------------------------------", White, 9 );
	      info( 28, "Lot size close of bar: " + DoubleToStr(lotSizeClose*10,2), Black, 10 );
	      info( 29, "R/R Ratio close of bar: " + DoubleToStr(rrRatioClose,3), Black, 10 );

	      
	      
	      
	

      
      


}








    


void sendTS()
{
   
     for (int i=OrdersTotal()-1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
                        {

                           if (OrderType() == OP_BUY  && OrderTakeProfit() == 0 && OrderMagicNumber() == 0)
                              {  
                                  orderResult= OrderModify(OrderTicket(), 0, OrderOpenPrice() - FakeSL*pointvalue, OrderOpenPrice() + FakeTP*pointvalue, 0, White);
                              }
                        }                
     for ( i=OrdersTotal()-1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
                        {          
                   
                           if (OrderType() == OP_SELL && OrderTakeProfit() == 0 && OrderMagicNumber() == 0)
                             {     
                                 orderResult= OrderModify(OrderTicket(), 0, OrderOpenPrice() + FakeSL*pointvalue, OrderOpenPrice() - FakeTP*pointvalue, 0, White);
                             }       
                        }                       
   
} 
   
   
   

void CloseOrders()
{
int l_error_0;
    for (int i=OrdersTotal()-1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
         {
         
            
              if (OrderType() == OP_BUY && (Bid >= TPDbl || Bid <= SLDbl))
                 {
                   bool ret = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),3);
                   if (ret) 
                     {
                       DoAlert(Symbol() + " closed " + " @ " + NormalizeDouble(OrderClosePrice(), Digits) 
                       + "\nYour Profit " + NormalizeDouble(OrderProfit(), 2) + " " + AccountCurrency());
                     } 
                       else 
                       {
                         l_error_0 = GetLastError();
                         if (l_error_0 > 0/* NO_ERROR */) 
                         {
                           Print("OrderClose failed, error=", l_error_0, ": ", ErrorDescription(l_error_0));
                           if (l_error_0 == 138/* REQUOTE */) DoAlert("MoneyManagement v2.6 tried to close a trade @" + DoubleToStr(Ask, Digits) + " but broker rejected order.");
                         }  
                       }       
                  }
              
              
                              
             if (OrderType() == OP_SELL && (Ask <=  TPDbl || Ask >=  SLDbl))
                {
                        ret = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),3);
                        if (ret) 
                          {
                            DoAlert(Symbol() + " closed " + " @ " + NormalizeDouble(OrderClosePrice(), Digits) 
                            + "\nYour Profit " + NormalizeDouble(OrderProfit(), 2) + " " + AccountCurrency());
                          } 
                              else 
                              {
                                l_error_0 = GetLastError();
                                if (l_error_0 > 0/* NO_ERROR */) 
                                {
                                 Print("OrderClose failed, error=", l_error_0, ": ", ErrorDescription(l_error_0));
                                 if (l_error_0 == 138/* REQUOTE */) DoAlert("MoneyManagement v2.6 tried to close a trade @" + DoubleToStr(Ask, Digits) + " but broker rejected order.");
                                }  
                              }       
                 }





         }
         
}     


void DoAlert(string as_0) {
   if (as_0 != gs_164) {
      if (Alert_With_Sound) PlaySound("alert.wav");
      MessageBox(as_0, "MoneyManagement v2.6", 0);
      gs_164 = as_0;
   }
}






void returnparameters(double& Opprice,bool& buyexist,bool& sellexist,bool& profit)


{



     for (int i=OrdersTotal()-1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
                        {

                           if (OrderType() == OP_BUY   && OrderMagicNumber() == 0)
                              {  
                                  buyexist = TRUE;
                                  Opprice = OrderOpenPrice();
                                    if (OrderProfit() > 0) profit =TRUE; else profit =FALSE;
                              }
                        }                
     for ( i=OrdersTotal()-1; i >= 0; i--)
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES))
                        {          
                   
                           if (OrderType() == OP_SELL  && OrderMagicNumber() == 0)
                             {     
                                 
                                 sellexist = true;
                                 Opprice = OrderOpenPrice();
                                 if (OrderProfit() > 0) profit =TRUE; else profit =FALSE;
                             }       
                        }                       




}
    


void getparameters(double& OP,double& TPr,double& SL)


{
      OP = values[0];
      TPr  = values[1];
      SL = values[2];
      
      
}


void writeparameters()
{
      values[0] = MathRound(ObjectGet(entry, OBJPROP_PRICE1) / pointvalue) * pointvalue;
      values[1]  = MathRound(ObjectGet(TP, OBJPROP_PRICE1) / pointvalue) * pointvalue;
      values[2] = MathRound(ObjectGet(stopLoss, OBJPROP_PRICE1) / pointvalue) * pointvalue;
      
      
      
}


void checkforposition()
{

   double oPrice;
   bool bexist,sexist,prof;
   returnparameters(oPrice,bexist,sexist,prof);
         if (bexist == TRUE && (values[1] < Close[0] || values[2] > Close[0]) )   
            {
                ObjectDelete(stopLoss);
                ObjectDelete(TP);
                ObjectDelete(entry);
                {entryvar =Close[0]; TPvar = (entryvar + pointvalue*10);  SLvar =  (entryvar -pointvalue*10);}
                
            }
             
         if (sexist == TRUE && (values[1] > Close[0] || values[2] < Close[0]))   
            {
                ObjectDelete(stopLoss);
                ObjectDelete(TP);
                ObjectDelete(entry);
                {entryvar =Close[0]; TPvar = (entryvar - pointvalue*10);  SLvar =  (entryvar + pointvalue*10);}
   
            
            }  
                
                   ObjectCreate(stopLoss, OBJ_HLINE, 0, datetimevar, SLvar);
                   ObjectSet(stopLoss, OBJPROP_COLOR, StopLossLineColor);
                   ObjectSet(stopLoss, OBJPROP_STYLE, STYLE_DASHDOTDOT);
                   ObjectSet(stopLoss, OBJPROP_WIDTH, 1);
   
                   ObjectCreate(entry, OBJ_HLINE, 0, datetimevar, entryvar);
                   ObjectSet(entry, OBJPROP_COLOR, entryLineColor);
                   ObjectSet(entry, OBJPROP_STYLE, STYLE_DASHDOTDOT);
                   ObjectSet(entry, OBJPROP_WIDTH, 1);

                   ObjectCreate(TP, OBJ_HLINE, 0, datetimevar, TPvar);
                   ObjectSet(TP, OBJPROP_COLOR, TPLineColor);
                   ObjectSet(TP, OBJPROP_STYLE, STYLE_DASHDOTDOT);
                   ObjectSet(TP, OBJPROP_WIDTH, 1);

}   


double balanceDeviation(int ai_0) {
   double ld_ret_4;
   if (ai_0 == 2) {
      ld_ret_4 = (AccountEquity() / AccountBalance() - 1.0) / (-0.01);
      if (ld_ret_4 > 0.0) return (ld_ret_4);
      return (0);
   }
   if (ai_0 == 1) {
      ld_ret_4 = 100.0 * (AccountEquity() / AccountBalance() - 1.0);
      if (ld_ret_4 > 0.0) return (ld_ret_4);
      return (0);
   }
   return (0.0);
}



/////////////////
// LabelCreate //                                                             




void info_init()
{
	for ( int row = 0; row <= 30; row ++ )
	{
		_LabelCreate( StringConcatenate( "InfoLabel_0", row ),   4, 15 + 15*row );
		
	}
}


void _LabelCreate ( string _Name, int _XDistance, int _YDistance, int _Corner = 0 )
{
	int _GetLastError;

	if ( !ObjectCreate( _Name, OBJ_LABEL, 0, 0, 0 ) )
	{
		_GetLastError = GetLastError();
		if ( _GetLastError != 4200 )
		{
			Print( "ObjectCreate( \"", _Name, "\", OBJ_LABEL,0,0,0 ) - Error #", _GetLastError );
			return;
		}
	}
	if ( !ObjectSet( _Name, OBJPROP_CORNER, _Corner ) )
	{
		_GetLastError = GetLastError();
		Print( "ObjectSet( \"", _Name, "\", OBJPROP_CORNER, ", _Corner, 
													" ) - Error #", _GetLastError );
	}
	if ( !ObjectSet( _Name, OBJPROP_XDISTANCE, _XDistance ) )
	{
		_GetLastError = GetLastError();
		Print( "ObjectSet( \"", _Name, "\", OBJPROP_XDISTANCE, ", _XDistance, 
															" ) - Error #", _GetLastError );
	}
	if ( !ObjectSet( _Name, OBJPROP_YDISTANCE, _YDistance ) )
	{
		_GetLastError = GetLastError();
		Print( "ObjectSet( \"", _Name, "\", OBJPROP_YDISTANCE, ", _YDistance, 
															" ) - Error #", _GetLastError );
	}
	if ( !ObjectSetText ( _Name, "", 10 ) )
	{
		_GetLastError = GetLastError();
		Print( "ObjectSetText( \"", _Name, "\", \"\", 10 ) - Error #", _GetLastError );
	}
}

void info_deinit()
{
	int _GetLastError;
	for ( int row = 0; row <= 30; row ++ )
	{
		if ( !ObjectDelete( StringConcatenate( "InfoLabel_0", row ) ) )
		{
			_GetLastError = GetLastError();
			Print( "ObjectDelete( \"", StringConcatenate( "InfoLabel_0", row ), 
															"\" ) - Error #", _GetLastError );
		}
		if ( !ObjectDelete( StringConcatenate( "InfoLabel_1", row ) ) )
		{
			_GetLastError = GetLastError();
			Print( "ObjectDelete( \"", StringConcatenate( "InfoLabel_1", row ), 
															"\" ) - Error #", _GetLastError );
		}
	}
}

void info( int LabelNumber, string Text, int Color = -1, 
			  double FontSize = -1.0, string Font = "-1" )
{
	string LabelName;
	
		LabelName = StringConcatenate( "InfoLabel_0", LabelNumber );

	if ( Color < 0 ) Color = lastusedColor;
	if ( FontSize < 0 ) FontSize = lastusedFontSize;
	if ( Font == "-1" ) Font = lastusedFont;

	lastusedColor = Color;
	lastusedFontSize = FontSize;
	lastusedFont = Font;

	if ( !ObjectSetText( LabelName, Text, FontSize, Font, Color ) )
	{
		int _GetLastError = GetLastError();
		Print( "ObjectSetText( \"", LabelName,"\", \"", Text, "\", ", FontSize, ", ", Font, 
															", ", Color, " ) - Error #", _GetLastError );
	}
	ObjectsRedraw();
}
void info_clear()
{
	for ( int n = 0;  n < 30;  n ++ ) info( n, "" );
	
}